
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Api_configsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const api_configs = await db.api_configs.create(
            {
                id: data.id || undefined,
        
        service_name: data.service_name
        ||
        null
            ,
            
        base_url: data.base_url
        ||
        null
            ,
            
        api_key_name: data.api_key_name
        ||
        null
            ,
            
        api_key_value: data.api_key_value
        ||
        null
            ,
            
        is_enabled: data.is_enabled
        ||
        false
        
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await api_configs.setCompany( data.company || null, {
            transaction,
        });
        
        await api_configs.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return api_configs;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const api_configsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                service_name: item.service_name
            ||
            null
            ,
            
                base_url: item.base_url
            ||
            null
            ,
            
                api_key_name: item.api_key_name
            ||
            null
            ,
            
                api_key_value: item.api_key_value
            ||
            null
            ,
            
                is_enabled: item.is_enabled
            ||
            false
        
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const api_configs = await db.api_configs.bulkCreate(api_configsData, { transaction });

        // For each item created, replace relation files
        

        return api_configs;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const api_configs = await db.api_configs.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.service_name !== undefined) updatePayload.service_name = data.service_name;
        
        
        if (data.base_url !== undefined) updatePayload.base_url = data.base_url;
        
        
        if (data.api_key_name !== undefined) updatePayload.api_key_name = data.api_key_name;
        
        
        if (data.api_key_value !== undefined) updatePayload.api_key_value = data.api_key_value;
        
        
        if (data.is_enabled !== undefined) updatePayload.is_enabled = data.is_enabled;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await api_configs.update(updatePayload, {transaction});

        
        
        if (data.company !== undefined) {
            await api_configs.setCompany(
              
              data.company,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await api_configs.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return api_configs;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const api_configs = await db.api_configs.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of api_configs) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of api_configs) {
                await record.destroy({transaction});
            }
        });


        return api_configs;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const api_configs = await db.api_configs.findByPk(id, options);

        await api_configs.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await api_configs.destroy({
            transaction
        });

        return api_configs;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const api_configs = await db.api_configs.findOne(
            { where },
            { transaction },
        );

        if (!api_configs) {
            return api_configs;
        }

        const output = api_configs.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.company = await api_configs.getCompany({
            transaction
        });
        
        
        output.organizations = await api_configs.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.companies,
        as: 'company',
        
        where: filter.company ? {
          [Op.or]: [
            { id: { [Op.in]: filter.company.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.company.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.service_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'api_configs',
                        'service_name',
                        filter.service_name,
                    ),
                };
            }
            
            if (filter.base_url) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'api_configs',
                        'base_url',
                        filter.base_url,
                    ),
                };
            }
            
            if (filter.api_key_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'api_configs',
                        'api_key_name',
                        filter.api_key_name,
                    ),
                };
            }
            
            if (filter.api_key_value) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'api_configs',
                        'api_key_value',
                        filter.api_key_value,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'api_configs',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_enabled) {
                where = {
                    ...where,
                is_enabled: filter.is_enabled,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.api_configs.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'api_configs',
                        'service_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.api_configs.findAll({
            attributes: [ 'id', 'service_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['service_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.service_name,
        }));
    }

    
};

